"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular/core");
let Draggable = class Draggable {
    constructor(element) {
        this.element = element;
        this._allowDrag = true;
    }
    ngOnInit() {
        if (this._allowDrag) {
            this.element.nativeElement.style.position = 'relative';
            this.element.nativeElement.className += ' cursor-draggable';
        }
    }
    onMouseDown(event) {
        if (event.button === 2 || (this._handle !== undefined && event.target !== this._handle))
            return;
        this.md = true;
        this.topStart = event.clientY - this.element.nativeElement.style.top.replace('px', '');
        this.leftStart = event.clientX - this.element.nativeElement.style.left.replace('px', '');
    }
    onMouseUp(event) {
        this.md = false;
    }
    onMouseMove(event) {
        if (this.md && this._allowDrag) {
            this.element.nativeElement.style.top = (event.clientY - this.topStart) + 'px';
            this.element.nativeElement.style.left = (event.clientX - this.leftStart) + 'px';
        }
    }
    onMouseLeave(event) {
        this.md = false;
    }
    onTouchStart(event) {
        this.md = true;
        this.topStart = event.changedTouches[0].clientY - this.element.nativeElement.style.top.replace('px', '');
        this.leftStart = event.changedTouches[0].clientX - this.element.nativeElement.style.left.replace('px', '');
        event.stopPropagation();
    }
    onTouchEnd() {
        this.md = false;
    }
    onTouchMove(event) {
        if (this.md && this._allowDrag) {
            this.element.nativeElement.style.top = (event.changedTouches[0].clientY - this.topStart) + 'px';
            this.element.nativeElement.style.left = (event.changedTouches[0].clientX - this.leftStart) + 'px';
        }
        event.stopPropagation();
    }
    set allowDrag(value) {
        this._allowDrag = value;
        if (this._allowDrag)
            this.element.nativeElement.className += ' cursor-draggable';
        else
            this.element.nativeElement.className = this.element.nativeElement.className
                .replace(' cursor-draggable', '');
    }
    set ng2DraggableHandle(handle) {
        this._handle = handle;
    }
};
__decorate([
    core_1.HostListener('mousedown', ['$event'])
], Draggable.prototype, "onMouseDown", null);
__decorate([
    core_1.HostListener('document:mouseup', ['$event'])
], Draggable.prototype, "onMouseUp", null);
__decorate([
    core_1.HostListener('document:mousemove', ['$event'])
], Draggable.prototype, "onMouseMove", null);
__decorate([
    core_1.HostListener('document:mouseleave', ['$event'])
], Draggable.prototype, "onMouseLeave", null);
__decorate([
    core_1.HostListener('touchstart', ['$event'])
], Draggable.prototype, "onTouchStart", null);
__decorate([
    core_1.HostListener('document:touchend', ['$event'])
], Draggable.prototype, "onTouchEnd", null);
__decorate([
    core_1.HostListener('document:touchmove', ['$event'])
], Draggable.prototype, "onTouchMove", null);
__decorate([
    core_1.Input('ng2-draggable')
], Draggable.prototype, "allowDrag", null);
__decorate([
    core_1.Input()
], Draggable.prototype, "ng2DraggableHandle", null);
Draggable = __decorate([
    core_1.Directive({
        selector: '[ng2-draggable]'
    })
], Draggable);
exports.Draggable = Draggable;
